package com.gyee.alarm.service;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import com.gyee.alarm.mapper.auto.AlarmTsMapper;
import com.gyee.alarm.model.auto.ProEconElectricaltestPoint;
import com.gyee.alarm.model.vo.AlarmSuperTalbeType;
import com.gyee.alarm.model.vo.AlarmTsVo;
import com.gyee.alarm.model.vo.AlarmTypeValue;
import com.gyee.alarm.model.vo.AlarmVo;
import com.gyee.alarm.util.DateUtils;
import com.gyee.alarm.util.SnowflakeGenerator;
import com.gyee.common.model.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


@Service

public class AlarmHistoryService   {

    @Resource
    private AlarmTsMapper alarmTsMapper;

    @Value("${home_pagep_size}")
    private int home_pagep_size;
    /**
     * 查询报警信息接口
     * @param begin 开始时间
     * @param end 结束时间
     * @param alarmType 报警类型
     * @param stationid 场站
     * @param description 描述
     * @param pageNum 页数
     * @param pageSize 每页多少条
     * @return
     */
    public Map<String,Object> findAlarmlist(String modelId, long begin,long end ,String alarmType,String stationid,String deviceid,String description,String deviceType, int pageNum, int pageSize) {

        Map<String,Object> map=new HashMap<>();

        List<AlarmVo> vos =new ArrayList<>();
        String superTableName= null;
        StringBuilder descriptionSql=new StringBuilder();
        if(StringUtils.notEmp(alarmType) && StringUtils.notEmp(begin) && StringUtils.notEmp(end) )
        {

//            whereSql.append(" where  ts>=").append(begin).append("  and ts<= ").append(end);
//
//            whereSql.append(" and alarmtype=CONCAT('',").append(alarmType).append(",'')");

           if(AlarmTypeValue.BT.getCode().equals(alarmType))
           {
               superTableName= AlarmSuperTalbeType.BT.getCode();

           }else if(AlarmTypeValue.WT.getCode().equals(alarmType))
           {
               superTableName= AlarmSuperTalbeType.WT.getCode();

           }else if(AlarmTypeValue.CT.getCode().equals(alarmType))
           {
               superTableName= AlarmSuperTalbeType.CT.getCode();

           }
        }

//        if(StringUtils.notEmp(stationid)  )
//        {
//            whereSql.append(" and stationid=CONCAT('',").append(stationid).append(",'')");
//
//        }
//        if(StringUtils.notEmp(deviceid)  )
//        {
//            whereSql.append(" and deviceid= CONCAT('',").append(deviceid).append(",'')");
//
//        }
//
        if(StringUtils.notEmp(description)  )
        {
            descriptionSql.append("%").append(description).append("%");
            description=String.valueOf(descriptionSql);
        }
        if(StringUtils.empty(deviceid)  )
        {
            deviceid=null;
        }

        if(StringUtils.empty(modelId)  )
        {
            modelId=null;
        }

        if(StringUtils.empty(description)  )
        {
            description=null;
        }
        if(StringUtils.empty(deviceType)  )
        {
            deviceType=null;
        }
        vos = alarmTsMapper.selectByWtLimit(begin,end,modelId,superTableName, alarmType, stationid, deviceid, description,deviceType, pageNum*pageSize, (pageNum*pageSize+pageSize));
        map.put("ls",vos);
        int total=alarmTsMapper.selectByWtCount(begin,end,modelId,superTableName, alarmType, stationid,deviceType, deviceid, description);
        map.put("total",total);
        return map;
    }



    public Map<String,Object> findAlarmByTypelist() {

        Map<String,Object> map=new HashMap<>();


            SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
            Date endDate = new Date();
            Date beginDate = DateUtils.truncate(endDate);


        List<AlarmVo> btls = alarmTsMapper.selectByWtLimit(beginDate.getTime(),endDate.getTime(),null,AlarmSuperTalbeType.BT.getCode(), AlarmTypeValue.BT.getCode(), null, null, null,null, 0, home_pagep_size);
        map.put("btls",btls);

        List<AlarmVo> wtls = alarmTsMapper.selectByWtLimit(beginDate.getTime(),endDate.getTime(),null,AlarmSuperTalbeType.WT.getCode(), AlarmTypeValue.WT.getCode(), null, null, null,null, 0, home_pagep_size);
        map.put("wtls",wtls);

        List<AlarmVo> ctls = alarmTsMapper.selectByWtLimit(beginDate.getTime(),endDate.getTime(),null,AlarmSuperTalbeType.CT.getCode(), AlarmTypeValue.CT.getCode(), null, null, null,null, 0, home_pagep_size);
        map.put("ctls",ctls);
        return map;
    }
//
//
//    public List<AlarmStat1> findByCondition(String stationId, Date startTime, Date endTime) {
//        List<AlarmStat1> resultList = new ArrayList<>();
//
//        List<FeatureStat> lst = featurePressureStatMapper.searchByCondition(stationId, startTime, endTime);
//
//        //根据统计类型分组  YYBYX,LWYC,ZPH,YPH
//        Map<String, List<FeatureStat>> typeGorupMap = lst.stream().collect(Collectors.groupingBy(FeatureStat::getTypeCode));
//
//
//        // region  存储偏航类统计,将左偏航和右偏航进行合并
//        Map<String, List<FeatureStat>> yawStatMap = new HashMap<>();
//
//        for (Map.Entry<String, List<FeatureStat>> entry : typeGorupMap.entrySet()) {
//
//            //如果统计信息不是左偏航和右偏航
//            if (!entry.getKey().contains("ZPH") && !entry.getKey().contains("YPH")) {
//                //根据风机编号分组
//                Map<String, List<FeatureStat>> groupMap = entry.getValue().stream().collect(Collectors.groupingBy(FeatureStat::getWtId));
//
//                for (Map.Entry<String, List<FeatureStat>> item : groupMap.entrySet()) {
//                    AlarmStat1 d = new AlarmStat1();
//                    if(entry.getKey().equals("JLDZ")){
//                        d.setRelateParts("PHXT");
//                        d.setRelatePartsText("偏航系统");
//                    }else{
//                        d.setRelateParts("YYXT");
//                        d.setRelatePartsText("液压系统");
//                    }
//
//                    if (item.getValue() != null && item.getValue().size() > 0) {
//                        FeatureStat stat = item.getValue().get(0);
//                        d.setAlertText(stat.getTypeName());
//                    } else {
//                        if (entry.getKey().equals("YYBYX")) {
//                            d.setAlertText("液压泵运行");
//                        } else if (entry.getKey().equals("LWYC")) {
//                            d.setAlertText("滤网压差");
//                        }
//                    }
//
//                    double time = 0;
//                    int count = 0;
//                    time = item.getValue().stream().mapToDouble(FeatureStat::getTotalSeconds).sum();
//                    count = item.getValue().stream().mapToInt(FeatureStat::getTotal).sum();
//                    d.setCount(count);
//                    //总时长以分钟为单位,不到一分钟则记为一分钟
//                    double finalTime = Math.ceil(time / 60.0);
//
//                    d.setTime(finalTime);
//                    d.setWindturbineId(item.getKey());
//                    d.setStationId(stationId);
//                    d.setSnapId(SnowflakeGenerator.generateId());
//                    resultList.add(d);
//                }
//            } else {
//                if (!yawStatMap.containsKey("PH")) {
//                    yawStatMap.put("PH", entry.getValue());
//                } else {
//                    List<FeatureStat> yawList = yawStatMap.get("PH");
//                    yawList.addAll(entry.getValue());
//                }
//            }
//        }
//        //endregion
//        //针对偏航类信息再次进行整合并将结果合并到resultList
//
//        for (Map.Entry<String, List<FeatureStat>> entry : yawStatMap.entrySet()) {
//            //根据风机编号进行分组
//            Map<String, List<FeatureStat>> groupMapByWindturbineId = entry.getValue().stream().collect(Collectors.groupingBy(FeatureStat::getWtId));
//            for (Map.Entry<String, List<FeatureStat>> item : groupMapByWindturbineId.entrySet()) {
//                AlarmStat1 d = new AlarmStat1();
//                d.setRelateParts("PHXT");
//                d.setRelatePartsText("偏航系统");
//                if (entry.getKey().equals("PH")) {
//                    d.setAlertText("偏航");
//                }
//
//
//                double time = 0;
//                int count = 0;
//                time = item.getValue().stream().mapToDouble(FeatureStat::getTotalSeconds).sum();
//                count = item.getValue().stream().mapToInt(FeatureStat::getTotal).sum();
//                d.setCount(count);
//                //总时长以分钟为单位,不到一分钟则记为一分钟
//                double finalTime = Math.ceil(time / 60.0);
//
//                d.setTime(finalTime);
//                d.setWindturbineId(item.getKey());
//                d.setStationId(stationId);
//                d.setSnapId(SnowflakeGenerator.generateId());
//                resultList.add(d);
//            }
//
//        }
//
//        return resultList;
//    }


}
